## libzstd 1.1.1

=== Makefile ===
# ################################################################
# Copyright (c) 2016-present, Yann Collet, Facebook, Inc.
# All rights reserved.
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree. An additional grant
# of patent rights can be found in the PATENTS file in the same directory.
# ################################################################

PRGDIR   = programs
ZSTDDIR  = lib
BUILDIR  = build
ZWRAPDIR = zlibWrapper
TESTDIR  = tests

# Define nul output
ifneq (,$(filter Windows%,$(OS)))
VOID = nul
else
VOID = /dev/null
endif

.PHONY: default all zlibwrapper zstd clean install uninstall travis-install test clangtest gpptest armtest usan asan uasan

default: libzstd zstd

all:
	$(MAKE) -C $(ZSTDDIR) $@
	$(MAKE) -C $(PRGDIR) $@ zstd32
	$(MAKE) -C $(TESTDIR) $@ all32

libzstd:
	@$(MAKE) -C $(ZSTDDIR)

zstd:
	@$(MAKE) -C $(PRGDIR)
	cp $(PRGDIR)/zstd .

zlibwrapper:
	$(MAKE) -C $(ZWRAPDIR) test

test:
	$(MAKE) -C $(TESTDIR) $@

clean:
	@$(MAKE) -C $(ZSTDDIR) $@ > $(VOID)
	@$(MAKE) -C $(PRGDIR) $@ > $(VOID)
	@$(MAKE) -C $(TESTDIR) $@ > $(VOID)
	@$(MAKE) -C $(ZWRAPDIR) $@ > $(VOID)
	@$(RM) zstd
	@echo Cleaning completed


#------------------------------------------------------------------------------
# make install is validated only for Linux, OSX, Hurd and some BSD targets
#------------------------------------------------------------------------------
ifneq (,$(filter $(shell uname),Linux Darwin GNU/kFreeBSD GNU FreeBSD DragonFly NetBSD))
HOST_OS = POSIX
install:
	@$(MAKE) -C $(ZSTDDIR) $@
	@$(MAKE) -C $(PRGDIR) $@

uninstall:
	@$(MAKE) -C $(ZSTDDIR) $@
	@$(MAKE) -C $(PRGDIR) $@

travis-install:
	$(MAKE) install PREFIX=~/install_test_dir

gpptest: clean
	$(MAKE) -C programs all CC=g++ CFLAGS="-O3 -Wall -Wextra -Wundef -Wshadow -Wcast-align -Werror"

gcc5test: clean
	gcc-5 -v
	$(MAKE) all CC=gcc-5 MOREFLAGS="-Werror"

gcc6test: clean
	gcc-6 -v
	$(MAKE) all CC=gcc-6 MOREFLAGS="-Werror"

clangtest: clean
	clang -v
	$(MAKE) all CC=clang MOREFLAGS="-Werror -Wconversion -Wno-sign-conversion -Wdocumentation"

armtest: clean
	$(MAKE) -C $(TESTDIR) datagen   # use native, faster
	$(MAKE) -C $(TESTDIR) test CC=arm-linux-gnueabi-gcc ZSTDRTTEST= MOREFLAGS="-Werror -static"

ppctest: clean
	$(MAKE) -C $(TESTDIR) datagen   # use native, faster
	$(MAKE) -C $(TESTDIR) test CC=powerpc-linux-gnu-gcc ZSTDRTTEST= MOREFLAGS="-Werror -Wno-attributes -static"

ppc64test: clean
	$(MAKE) -C $(TESTDIR) datagen   # use native, faster
	$(MAKE) -C $(TESTDIR) test CC=powerpc-linux-gnu-gcc ZSTDRTTEST= MOREFLAGS="-m64 -static"

usan: clean
	$(MAKE) test CC=clang MOREFLAGS="-g -fsanitize=undefined"

asan: clean
	$(MAKE) test CC=clang MOREFLAGS="-g -fsanitize=address"

msan: clean
	$(MAKE) test CC=clang MOREFLAGS="-g -fsanitize=memory -fno-omit-frame-pointer"   # datagen.c fails this test for no obvious reason

asan32: clean
	$(MAKE) -C $(TESTDIR) test32 CC=clang MOREFLAGS="-g -fsanitize=address"

uasan: clean
	$(MAKE) test CC=clang MOREFLAGS="-g -fsanitize=address -fsanitize=undefined"

endif


ifneq (,$(filter MSYS%,$(shell uname)))
HOST_OS = MSYS
CMAKE_PARAMS = -G"MSYS Makefiles"
endif


#------------------------------------------------------------------------
#make tests validated only for MSYS, Linux, OSX, kFreeBSD and Hurd targets
#------------------------------------------------------------------------
ifneq (,$(filter $(HOST_OS),MSYS POSIX))
cmaketest:
	cmake --version
	$(RM) -r $(BUILDIR)/cmake/build
	mkdir $(BUILDIR)/cmake/build
	cd $(BUILDIR)/cmake/build ; cmake -DPREFIX:STRING=~/install_test_dir $(CMAKE_PARAMS) .. ; $(MAKE) install ; $(MAKE) uninstall

c90test: clean
	CFLAGS="-std=c90" $(MAKE) all  # will fail, due to // and long long

gnu90test: clean
	CFLAGS="-std=gnu90" $(MAKE) all

c99test: clean
	CFLAGS="-std=c99" $(MAKE) all

gnu99test: clean
	CFLAGS="-std=gnu99" $(MAKE) all

c11test: clean
	CFLAGS="-std=c11" $(MAKE) all

bmix64test: clean
	CFLAGS="-O3 -mbmi -Werror" $(MAKE) -C $(TESTDIR) test

bmix32test: clean
	CFLAGS="-O3 -mbmi -mx32 -Werror" $(MAKE) -C $(TESTDIR) test

bmi32test: clean
	CFLAGS="-O3 -mbmi -m32 -Werror" $(MAKE) -C $(TESTDIR) test

staticAnalyze: clean
	CPPFLAGS=-g scan-build --status-bugs -v $(MAKE) all
endif

=== lib/Makefile ===
# ################################################################
# Copyright (c) 2016-present, Yann Collet, Facebook, Inc.
# All rights reserved.
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree. An additional grant
# of patent rights can be found in the PATENTS file in the same directory.
# ################################################################

# Version numbers
LIBVER_MAJOR_SCRIPT:=`sed -n '/define ZSTD_VERSION_MAJOR/s/.*[[:blank:]]\([0-9][0-9]*\).*/\1/p' < ./zstd.h`
LIBVER_MINOR_SCRIPT:=`sed -n '/define ZSTD_VERSION_MINOR/s/.*[[:blank:]]\([0-9][0-9]*\).*/\1/p' < ./zstd.h`
LIBVER_PATCH_SCRIPT:=`sed -n '/define ZSTD_VERSION_RELEASE/s/.*[[:blank:]]\([0-9][0-9]*\).*/\1/p' < ./zstd.h`
LIBVER_SCRIPT:= $(LIBVER_MAJOR_SCRIPT).$(LIBVER_MINOR_SCRIPT).$(LIBVER_PATCH_SCRIPT)
LIBVER_MAJOR := $(shell echo $(LIBVER_MAJOR_SCRIPT))
LIBVER_MINOR := $(shell echo $(LIBVER_MINOR_SCRIPT))
LIBVER_PATCH := $(shell echo $(LIBVER_PATCH_SCRIPT))
LIBVER := $(shell echo $(LIBVER_SCRIPT))
VERSION?= $(LIBVER)

DESTDIR?=
PREFIX ?= /usr/local
LIBDIR ?= $(PREFIX)/lib
INCLUDEDIR=$(PREFIX)/include

CPPFLAGS= -I. -I./common
CFLAGS ?= -O3
CFLAGS += -Wall -Wextra -Wcast-qual -Wcast-align -Wshadow -Wstrict-aliasing=1 \
          -Wswitch-enum -Wdeclaration-after-statement -Wstrict-prototypes -Wundef
FLAGS   = $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) $(MOREFLAGS)


ZSTD_FILES := common/*.c compress/*.c decompress/*.c dictBuilder/*.c

ifeq ($(ZSTD_LEGACY_SUPPORT), 0)
CPPFLAGS  += -DZSTD_LEGACY_SUPPORT=0
else
ZSTD_FILES+= legacy/*.c
CPPFLAGS  += -I./legacy -DZSTD_LEGACY_SUPPORT=1
endif


# OS X linker doesn't support -soname, and use different extension
# see : https://developer.apple.com/library/mac/documentation/DeveloperTools/Conceptual/DynamicLibraries/100-Articles/DynamicLibraryDesignGuidelines.html
ifeq ($(shell uname), Darwin)
	SHARED_EXT = dylib
	SHARED_EXT_MAJOR = $(LIBVER_MAJOR).$(SHARED_EXT)
	SHARED_EXT_VER = $(LIBVER).$(SHARED_EXT)
	SONAME_FLAGS = -install_name $(PREFIX)/lib/$@.$(SHARED_EXT_MAJOR) -compatibility_version $(LIBVER_MAJOR) -current_version $(LIBVER)
else
	SONAME_FLAGS = -Wl,-soname=$@.$(SHARED_EXT).$(LIBVER_MAJOR)
	SHARED_EXT = so
	SHARED_EXT_MAJOR = $(SHARED_EXT).$(LIBVER_MAJOR)
	SHARED_EXT_VER = $(SHARED_EXT).$(LIBVER)
endif


.PHONY: default all clean install uninstall

default: clean libzstd

all: clean libzstd

libzstd: $(ZSTD_FILES)
	@echo compiling static library
	@$(CC) $(FLAGS) -c $^
	@$(AR) rcs $@.a *.o
	@echo compiling dynamic library $(LIBVER)
	@$(CC) $(FLAGS) -shared $^ -fPIC $(SONAME_FLAGS) -o $@.$(SHARED_EXT_VER)
	@echo creating versioned links
	@ln -sf $@.$(SHARED_EXT_VER) $@.$(SHARED_EXT_MAJOR)
	@ln -sf $@.$(SHARED_EXT_VER) $@.$(SHARED_EXT)

clean:
	@rm -f core *.o *.a *.gcda *.$(SHARED_EXT) *.$(SHARED_EXT).* libzstd.pc
	@rm -f decompress/*.o
	@echo Cleaning library completed

#------------------------------------------------------------------------
#make install is validated only for Linux, OSX, kFreeBSD, Hurd and some BSD targets
ifneq (,$(filter $(shell uname),Linux Darwin GNU/kFreeBSD GNU FreeBSD DragonFly NetBSD))

libzstd.pc:
libzstd.pc: libzstd.pc.in
	@echo creating pkgconfig
	@sed -e 's|@PREFIX@|$(PREFIX)|' \
             -e 's|@LIBDIR@|$(LIBDIR)|' \
             -e 's|@INCLUDEDIR@|$(INCLUDEDIR)|' \
             -e 's|@VERSION@|$(VERSION)|' \
             $< >$@

install: libzstd libzstd.pc
	@install -d -m 755 $(DESTDIR)$(LIBDIR)/pkgconfig/ $(DESTDIR)$(INCLUDEDIR)/
	@install -m 755 libzstd.$(SHARED_EXT_VER) $(DESTDIR)$(LIBDIR)/libzstd.$(SHARED_EXT_VER)
	@cp -a libzstd.$(SHARED_EXT_MAJOR) $(DESTDIR)$(LIBDIR)
	@cp -a libzstd.$(SHARED_EXT) $(DESTDIR)$(LIBDIR)
	@cp -a libzstd.pc $(DESTDIR)$(LIBDIR)/pkgconfig/
	@install -m 644 libzstd.a $(DESTDIR)$(LIBDIR)/libzstd.a
	@install -m 644 zstd.h $(DESTDIR)$(INCLUDEDIR)/zstd.h
	@install -m 644 common/zstd_errors.h $(DESTDIR)$(INCLUDEDIR)/zstd_errors.h
	@install -m 644 common/zbuff.h $(DESTDIR)$(INCLUDEDIR)/zbuff.h   # Deprecated streaming functions
	@install -m 644 dictBuilder/zdict.h $(DESTDIR)$(INCLUDEDIR)/zdict.h
	@echo zstd static and shared library installed

uninstall:
	@$(RM) $(DESTDIR)$(LIBDIR)/libzstd.a
	@$(RM) $(DESTDIR)$(LIBDIR)/libzstd.$(SHARED_EXT)
	@$(RM) $(DESTDIR)$(LIBDIR)/libzstd.$(SHARED_EXT_MAJOR)
	@$(RM) $(DESTDIR)$(LIBDIR)/libzstd.$(SHARED_EXT_VER)
	@$(RM) $(DESTDIR)$(LIBDIR)/pkgconfig/libzstd.pc
	@$(RM) $(DESTDIR)$(INCLUDEDIR)/zstd.h
	@$(RM) $(DESTDIR)$(INCLUDEDIR)/zstd_errors.h
	@$(RM) $(DESTDIR)$(INCLUDEDIR)/zbuff.h   # Deprecated streaming functions
	@$(RM) $(DESTDIR)$(INCLUDEDIR)/zdict.h
	@echo zstd libraries successfully uninstalled

endif

=== programs/Makefile ===
# ##########################################################################
# Copyright (c) 2016-present, Yann Collet, Facebook, Inc.
# All rights reserved.
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree. An additional grant
# of patent rights can be found in the PATENTS file in the same directory.
# ##########################################################################
# zstd : Command Line Utility, supporting gzip-like arguments
# zstd32 : Same as zstd, but forced to compile in 32-bits mode
# zstd_nolegacy : zstd without support of decompression of legacy versions
# zstd-small : minimal zstd without dictionary builder and benchmark
# zstd-compress : compressor-only version of zstd
# zstd-decompress : decompressor-only version of zstd
# ##########################################################################

DESTDIR?=
PREFIX ?= /usr/local
BINDIR  = $(PREFIX)/bin
MANDIR  = $(PREFIX)/share/man/man1

ZSTDDIR = ../lib

ifeq ($(shell $(CC) -v 2>&1 | grep -c "gcc version "), 1)
ALIGN_LOOP = -falign-loops=32
else
ALIGN_LOOP =
endif

CPPFLAGS= -I$(ZSTDDIR) -I$(ZSTDDIR)/common -I$(ZSTDDIR)/dictBuilder
CFLAGS ?= -O3
CFLAGS += -Wall -Wextra -Wcast-qual -Wcast-align -Wshadow -Wstrict-aliasing=1 \
          -Wswitch-enum -Wdeclaration-after-statement -Wstrict-prototypes -Wundef
CFLAGS += $(MOREFLAGS)
FLAGS   = $(CPPFLAGS) $(CFLAGS) $(LDFLAGS)


ZSTDCOMMON_FILES := $(ZSTDDIR)/common/*.c
ZSTDCOMP_FILES := $(ZSTDDIR)/compress/zstd_compress.c $(ZSTDDIR)/compress/fse_compress.c $(ZSTDDIR)/compress/huf_compress.c
ZSTDDECOMP_FILES := $(ZSTDDIR)/decompress/huf_decompress.c
ZSTD_FILES := $(ZSTDDECOMP_FILES) $(ZSTDCOMMON_FILES) $(ZSTDCOMP_FILES)
ZDICT_FILES := $(ZSTDDIR)/dictBuilder/*.c
ZSTDDECOMP_O = $(ZSTDDIR)/decompress/zstd_decompress.o
ZSTDDECOMP32_O = $(ZSTDDIR)/decompress/zstd_decompress32.o

ifeq ($(ZSTD_LEGACY_SUPPORT), 0)
CPPFLAGS  += -DZSTD_LEGACY_SUPPORT=0
ZSTDLEGACY_FILES:=
else
ZSTD_LEGACY_SUPPORT:=1
CPPFLAGS  += -I$(ZSTDDIR)/legacy
ZSTDLEGACY_FILES:= $(ZSTDDIR)/legacy/*.c
endif


# Define *.exe as extension for Windows systems
ifneq (,$(filter Windows%,$(OS)))
EXT =.exe
VOID = nul
RES64_FILE = windres\zstd64.res
RES32_FILE = windres\zstd32.res
ifneq (,$(filter x86_64%,$(shell $(CC) -dumpmachine)))
    RES_FILE = $(RES64_FILE)
else
    RES_FILE = $(RES32_FILE)
endif
else
EXT =
VOID = /dev/null
endif


.PHONY: default all clean clean_decomp_o install uninstall generate_res

default: zstd

all: zstd

$(ZSTDDECOMP_O): CPPFLAGS += -DZSTD_LEGACY_SUPPORT=$(ZSTD_LEGACY_SUPPORT)
$(ZSTDDECOMP_O): CFLAGS += $(ALIGN_LOOP)
$(ZSTDDECOMP_O): $(ZSTDDIR)/decompress/zstd_decompress.c

zstd  : $(ZSTDDECOMP_O) $(ZSTD_FILES) $(ZSTDLEGACY_FILES) $(ZDICT_FILES) \
        zstdcli.c fileio.c bench.c datagen.c dibio.c
ifneq (,$(filter Windows%,$(OS)))
	windres\generate_res.bat
endif
	$(CC)      $(FLAGS) -DZSTD_LEGACY_SUPPORT=$(ZSTD_LEGACY_SUPPORT) $^ $(RES_FILE) -o $@$(EXT)


$(ZSTDDECOMP32_O): $(ZSTDDIR)/decompress/zstd_decompress.c
	$(CC)  -m32 $(ALIGN_LOOP) $(FLAGS) -DZSTD_LEGACY_SUPPORT=$(ZSTD_LEGACY_SUPPORT) $^ -c -o $@

zstd32 : $(ZSTDDECOMP32_O) $(ZSTD_FILES) $(ZSTDLEGACY_FILES) $(ZDICT_FILES) \
        zstdcli.c fileio.c bench.c datagen.c dibio.c
ifneq (,$(filter Windows%,$(OS)))
	windres\generate_res.bat
endif
	$(CC)  -m32 $(FLAGS) -DZSTD_LEGACY_SUPPORT=$(ZSTD_LEGACY_SUPPORT) $^ $(RES32_FILE) -o $@$(EXT)


zstd_nolegacy : clean_decomp_o
	$(MAKE) zstd ZSTD_LEGACY_SUPPORT=0

zstd-pgo : MOREFLAGS = -fprofile-generate
zstd-pgo : clean zstd
	./zstd -b19i1 $(PROFILE_WITH)
	./zstd -b16i1 $(PROFILE_WITH)
	./zstd -b9i2 $(PROFILE_WITH)
	./zstd -b $(PROFILE_WITH)
	./zstd -b7i2 $(PROFILE_WITH)
	./zstd -b5 $(PROFILE_WITH)
	$(RM) zstd
	$(RM) $(ZSTDDIR)/decompress/zstd_decompress.o
	$(MAKE) zstd MOREFLAGS=-fprofile-use

zstd-frugal: $(ZSTDDECOMP_O) $(ZSTD_FILES) zstdcli.c fileio.c
	$(CC)      $(FLAGS) -DZSTD_NOBENCH -DZSTD_NODICT $^ -o zstd$(EXT)

zstd-small: clean_decomp_o
	ZSTD_LEGACY_SUPPORT=0 CFLAGS="-Os -s" $(MAKE) zstd-frugal

zstd-decompress-clean: $(ZSTDDECOMP_O) $(ZSTDCOMMON_FILES) $(ZSTDDECOMP_FILES) zstdcli.c fileio.c
	$(CC)      $(FLAGS) -DZSTD_NOBENCH -DZSTD_NODICT -DZSTD_NOCOMPRESS $^ -o zstd-decompress$(EXT)

zstd-decompress: clean_decomp_o
	ZSTD_LEGACY_SUPPORT=0 $(MAKE) zstd-decompress-clean

zstd-compress: $(ZSTDCOMMON_FILES) $(ZSTDCOMP_FILES) zstdcli.c fileio.c
	$(CC)      $(FLAGS) -DZSTD_NOBENCH -DZSTD_NODICT -DZSTD_NODECOMPRESS $^ -o $@$(EXT)

generate_res:
	windres\generate_res.bat

clean:
	$(MAKE) -C ../lib clean
	@$(RM) $(ZSTDDIR)/decompress/*.o $(ZSTDDIR)/decompress/zstd_decompress.gcda
	@$(RM) core *.o tmp* result* *.gcda dictionary *.zst \
        zstd$(EXT) zstd32$(EXT) zstd-compress$(EXT) zstd-decompress$(EXT) \
        *.gcda default.profraw
	@echo Cleaning completed

clean_decomp_o:
	@$(RM) $(ZSTDDECOMP_O)
	@$(RM) $(ZSTDDECOMP32_O)


#----------------------------------------------------------------------------------
#make install is validated only for Linux, OSX, kFreeBSD, Hurd and some BSD targets
#----------------------------------------------------------------------------------
ifneq (,$(filter $(shell uname),Linux Darwin GNU/kFreeBSD GNU OpenBSD FreeBSD DragonFly NetBSD))
install: zstd
	@echo Installing binaries
	@install -d -m 755 $(DESTDIR)$(BINDIR)/ $(DESTDIR)$(MANDIR)/
	@install -m 755 zstd$(EXT) $(DESTDIR)$(BINDIR)/zstd$(EXT)
	@ln -sf zstd$(EXT) $(DESTDIR)$(BINDIR)/zstdcat
	@ln -sf zstd$(EXT) $(DESTDIR)$(BINDIR)/unzstd
	@echo Installing man pages
	@install -m 644 zstd.1 $(DESTDIR)$(MANDIR)/zstd.1
	@ln -sf zstd.1 $(DESTDIR)$(MANDIR)/zstdcat.1
	@ln -sf zstd.1 $(DESTDIR)$(MANDIR)/unzstd.1
	@echo zstd installation completed

uninstall:
	@$(RM) $(DESTDIR)$(BINDIR)/zstdcat
	@$(RM) $(DESTDIR)$(BINDIR)/unzstd
	@$(RM) $(DESTDIR)$(BINDIR)/zstd$(EXT)
	@$(RM) $(DESTDIR)$(MANDIR)/zstdcat.1
	@$(RM) $(DESTDIR)$(MANDIR)/unzstd.1
	@$(RM) $(DESTDIR)$(MANDIR)/zstd.1
	@echo zstd programs successfully uninstalled
endif

## libzstd 1.1.2

=== lib/Makefile ===
--- 
+++ 
@@ -23,22 +23,23 @@
 LIBDIR ?= $(PREFIX)/lib
 INCLUDEDIR=$(PREFIX)/include
 
-CPPFLAGS= -I. -I./common
-CFLAGS ?= -O3
-CFLAGS += -Wall -Wextra -Wcast-qual -Wcast-align -Wshadow -Wstrict-aliasing=1 \
-          -Wswitch-enum -Wdeclaration-after-statement -Wstrict-prototypes -Wundef
-FLAGS   = $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) $(MOREFLAGS)
+CPPFLAGS+= -I. -I./common -DXXH_NAMESPACE=ZSTD_
+CFLAGS  ?= -O3
+CFLAGS  += -Wall -Wextra -Wcast-qual -Wcast-align -Wshadow -Wstrict-aliasing=1 \
+           -Wswitch-enum -Wdeclaration-after-statement -Wstrict-prototypes -Wundef \
+           -Wpointer-arith
+CFLAGS  += $(MOREFLAGS)
+FLAGS    = $(CPPFLAGS) $(CFLAGS)
 
 
-ZSTD_FILES := common/*.c compress/*.c decompress/*.c dictBuilder/*.c
+ZSTD_FILES := $(wildcard common/*.c compress/*.c decompress/*.c dictBuilder/*.c deprecated/*.c)
 
 ifeq ($(ZSTD_LEGACY_SUPPORT), 0)
 CPPFLAGS  += -DZSTD_LEGACY_SUPPORT=0
 else
-ZSTD_FILES+= legacy/*.c
 CPPFLAGS  += -I./legacy -DZSTD_LEGACY_SUPPORT=1
+ZSTD_FILES+= $(wildcard legacy/*.c)
 endif
-
 
 # OS X linker doesn't support -soname, and use different extension
 # see : https://developer.apple.com/library/mac/documentation/DeveloperTools/Conceptual/DynamicLibraries/100-Articles/DynamicLibraryDesignGuidelines.html
@@ -46,34 +47,49 @@
 	SHARED_EXT = dylib
 	SHARED_EXT_MAJOR = $(LIBVER_MAJOR).$(SHARED_EXT)
 	SHARED_EXT_VER = $(LIBVER).$(SHARED_EXT)
-	SONAME_FLAGS = -install_name $(PREFIX)/lib/$@.$(SHARED_EXT_MAJOR) -compatibility_version $(LIBVER_MAJOR) -current_version $(LIBVER)
+	SONAME_FLAGS = -install_name $(LIBDIR)/libzstd.$(SHARED_EXT_MAJOR) -compatibility_version $(LIBVER_MAJOR) -current_version $(LIBVER)
 else
-	SONAME_FLAGS = -Wl,-soname=$@.$(SHARED_EXT).$(LIBVER_MAJOR)
+	SONAME_FLAGS = -Wl,-soname=libzstd.$(SHARED_EXT).$(LIBVER_MAJOR)
 	SHARED_EXT = so
 	SHARED_EXT_MAJOR = $(SHARED_EXT).$(LIBVER_MAJOR)
 	SHARED_EXT_VER = $(SHARED_EXT).$(LIBVER)
 endif
 
+LIBZSTD = libzstd.$(SHARED_EXT_VER)
+
 
 .PHONY: default all clean install uninstall
 
-default: clean libzstd
+default: lib
 
-all: clean libzstd
+all: lib
 
-libzstd: $(ZSTD_FILES)
+libzstd.a: ARFLAGS = rcs
+libzstd.a: $(ZSTD_FILES)
 	@echo compiling static library
 	@$(CC) $(FLAGS) -c $^
-	@$(AR) rcs $@.a *.o
+	@$(AR) $(ARFLAGS) $@ *.o
+
+$(LIBZSTD): LDFLAGS += -shared -fPIC -fvisibility=hidden
+$(LIBZSTD): $(ZSTD_FILES)
 	@echo compiling dynamic library $(LIBVER)
-	@$(CC) $(FLAGS) -shared $^ -fPIC $(SONAME_FLAGS) -o $@.$(SHARED_EXT_VER)
+ifneq (,$(filter Windows%,$(OS)))
+	@$(CC) $(FLAGS) -DZSTD_DLL_EXPORT=1 -shared $^ -o dll\libzstd.dll
+	dlltool -D dll\libzstd.dll -d dll\libzstd.def -l dll\libzstd.lib
+else
+	@$(CC) $(FLAGS) $^ $(LDFLAGS) $(SONAME_FLAGS) -o $@
 	@echo creating versioned links
-	@ln -sf $@.$(SHARED_EXT_VER) $@.$(SHARED_EXT_MAJOR)
-	@ln -sf $@.$(SHARED_EXT_VER) $@.$(SHARED_EXT)
+	@ln -sf $@ libzstd.$(SHARED_EXT_MAJOR)
+	@ln -sf $@ libzstd.$(SHARED_EXT)
+endif
+
+libzstd : $(LIBZSTD)
+
+lib: libzstd.a libzstd
 
 clean:
-	@rm -f core *.o *.a *.gcda *.$(SHARED_EXT) *.$(SHARED_EXT).* libzstd.pc
-	@rm -f decompress/*.o
+	@$(RM) core *.o *.a *.gcda *.$(SHARED_EXT) *.$(SHARED_EXT).* libzstd.pc dll/libzstd.dll dll/libzstd.lib
+	@$(RM) decompress/*.o
 	@echo Cleaning library completed
 
 #------------------------------------------------------------------------
@@ -89,17 +105,17 @@
              -e 's|@VERSION@|$(VERSION)|' \
              $< >$@
 
-install: libzstd libzstd.pc
+install: libzstd.a libzstd libzstd.pc
 	@install -d -m 755 $(DESTDIR)$(LIBDIR)/pkgconfig/ $(DESTDIR)$(INCLUDEDIR)/
-	@install -m 755 libzstd.$(SHARED_EXT_VER) $(DESTDIR)$(LIBDIR)/libzstd.$(SHARED_EXT_VER)
+	@install -m 755 libzstd.$(SHARED_EXT_VER) $(DESTDIR)$(LIBDIR)
 	@cp -a libzstd.$(SHARED_EXT_MAJOR) $(DESTDIR)$(LIBDIR)
 	@cp -a libzstd.$(SHARED_EXT) $(DESTDIR)$(LIBDIR)
 	@cp -a libzstd.pc $(DESTDIR)$(LIBDIR)/pkgconfig/
-	@install -m 644 libzstd.a $(DESTDIR)$(LIBDIR)/libzstd.a
-	@install -m 644 zstd.h $(DESTDIR)$(INCLUDEDIR)/zstd.h
-	@install -m 644 common/zstd_errors.h $(DESTDIR)$(INCLUDEDIR)/zstd_errors.h
-	@install -m 644 common/zbuff.h $(DESTDIR)$(INCLUDEDIR)/zbuff.h   # Deprecated streaming functions
-	@install -m 644 dictBuilder/zdict.h $(DESTDIR)$(INCLUDEDIR)/zdict.h
+	@install -m 644 libzstd.a $(DESTDIR)$(LIBDIR)
+	@install -m 644 zstd.h $(DESTDIR)$(INCLUDEDIR)
+	@install -m 644 common/zstd_errors.h $(DESTDIR)$(INCLUDEDIR)
+	@install -m 644 deprecated/zbuff.h $(DESTDIR)$(INCLUDEDIR)     # prototypes generate deprecation warnings
+	@install -m 644 dictBuilder/zdict.h $(DESTDIR)$(INCLUDEDIR)
 	@echo zstd static and shared library installed
 
 uninstall:

=== debian/changelog ===
libzstd (1.1.2-1+deb9u1) stretch-security; urgency=high

  * Team upload.
  * When a file with restricted permissions is compressed, the resulting file
    inherits the umask of the user for the time of the compression. This will
    usually lead to surprising and too relaxed permissions. This update adds
    0010-fix-file-permissions-on-compression.patch to make sure the compressed
    file is not group nor world readable for the entire duration of the
    compression.
    Closes: #981404, #982519

 -- Étienne Mollier <etienne.mollier@mailoo.org>  Sat, 20 Feb 2021 09:43:24 +0100

libzstd (1.1.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 1.1.2

 -- Sascha Steinbiss <satta@debian.org>  Sun, 15 Jan 2017 08:08:53 +0000

libzstd (1.1.1-1) unstable; urgency=medium

  * New upstream version 1.1.1 (Closes: #844248)
  * Whitespace fix to d/control
  * Ensure hardening flags pass through to compiler by appending to CPPFLAGS

 -- Kevin Murray <kdmfoss@gmail.com>  Sun, 20 Nov 2016 16:12:58 +0100

libzstd (1.1.0-1) unstable; urgency=medium

  * New upstream version 1.1.0 (Closes: #839960)
  * Change uploader email
  * Build new pzstd binary, including manpage
  * Fix miscellaneous issues with d/rules and d/*.install
  * Move docs from libzstd-dev to the zstd binary

 -- Kevin Murray <kdmfoss@gmail.com>  Sun, 13 Nov 2016 11:23:03 +0000

libzstd (1.0.0-1) unstable; urgency=medium

  * Imported Upstream version 1.0.0 (Closes: #836574)
  * Bump library package name to libzstd1
  * Changed project URLs, copyrights after move to facebook.
  * d/rules: hardening=+all

 -- Kevin Murray <kdmfoss@gmail.com>  Sun, 04 Sep 2016 14:45:24 +1000

=== debian/control ===
Source: libzstd
Priority: optional
Maintainer: Debian Med Packaging <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Kevin Murray <kdmfoss@gmail.com>,
Build-Depends: debhelper (>= 9),
               d-shlibs,
Standards-Version: 3.9.8
Section: libs
Homepage: https://github.com/facebook/zstd
Vcs-Git: https://anonscm.debian.org/git/debian-med/libzstd.git
Vcs-Browser: https://anonscm.debian.org/git/debian-med/libzstd.git

Package: libzstd-dev
Architecture: any
Section: libdevel
Depends: libzstd1 (= ${binary:Version}),
         ${misc:Depends},
Description: fast lossless compression algorithm -- development files
 Zstd, short for Zstandard, is a fast lossless compression algorithm, targeting
 real-time compression scenarios at zlib-level compression ratio.
 .
 This package contains the headers and static library.


Package: libzstd1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
Description: fast lossless compression algorithm
 Zstd, short for Zstandard, is a fast lossless compression algorithm, targeting
 real-time compression scenarios at zlib-level compression ratio.
 .
 This package contains the shared library.


Package: zstd
Architecture: any
Section: utils
Depends: libzstd1 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends},
Description: fast lossless compression algorithm -- CLI tool
 Zstd, short for Zstandard, is a fast lossless compression algorithm, targeting
 real-time compression scenarios at zlib-level compression ratio.
 .
 This package contains the CLI program implementing zstd.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# Upstream's makefiles will respect PREFIX, and this means we avoid a patch
export PREFIX=/usr

%:
	dh $@ --parallel

override_dh_auto_build:
	dh_auto_build
	$(MAKE) -C contrib/pzstd/ pzstd

override_dh_install:
	# Call d-shlibmove to comply with library packaging guide
	d-shlibmove --commit \
				--multiarch \
				--devunversioned \
				--exclude-la \
				--movedev "debian/tmp/usr/include/*" usr/include \
				--movedev "debian/tmp/usr/lib/pkgconfig/*" usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
				debian/tmp/usr/lib/lib*.so
	dh_install

=== debian/watch ===
version=3
opts="filenamemangle=s/(?:.*?)?v?(\d[\d.]*)\.tar\.gz/libzstd_$1.tar.gz/" \
  https://github.com/facebook/zstd/releases .*/archive/v?(\d\S*)\.tar\.gz

## libzstd 1.3.1+dfsg

=== zlibWrapper/Makefile ===
# Makefile for example of using zstd wrapper for zlib
#
# make - compiles examples
# make MOREFLAGS=-DZWRAP_USE_ZSTD=1 - compiles examples with zstd compression turned on
# make test - runs examples


# Paths to static and dynamic zlib and zstd libraries
# Use "make ZLIB_PATH=path/to/zlib ZLIB_LIBRARY=path/to/libz.a" to select a path to library
ZLIB_LIBRARY ?= -lz
ZLIB_PATH ?= .

ZSTDLIBDIR = ../lib
ZSTDLIBRARY = $(ZSTDLIBDIR)/libzstd.a
ZLIBWRAPPER_PATH = .
GZFILES = gzclose.o gzlib.o gzread.o gzwrite.o
EXAMPLE_PATH = examples
PROGRAMS_PATH = ../programs
TEST_FILE = ../doc/zstd_compression_format.md

CPPFLAGS = -DXXH_NAMESPACE=ZSTD_ -I$(ZLIB_PATH) -I$(PROGRAMS_PATH)       \
           -I$(ZSTDLIBDIR) -I$(ZSTDLIBDIR)/common -I$(ZLIBWRAPPER_PATH)
CFLAGS  ?= $(MOREFLAGS) -O3 -std=gnu99
CFLAGS  += -Wall -Wextra -Wcast-qual -Wcast-align -Wshadow -Wswitch-enum \
           -Wdeclaration-after-statement -Wstrict-prototypes -Wundef     \
           -Wstrict-aliasing=1


# Define *.exe as extension for Windows systems
ifneq (,$(filter Windows%,$(OS)))
EXT =.exe
else
EXT =
endif


all: clean fitblk example zwrapbench minigzip

test: example fitblk example_zstd fitblk_zstd zwrapbench minigzip minigzip_zstd
	./example
	./example_zstd
	./fitblk 10240 <$(TEST_FILE)
	./fitblk 40960 <$(TEST_FILE)
	./fitblk_zstd 10240 <$(TEST_FILE)
	./fitblk_zstd 40960 <$(TEST_FILE)
	@echo ---- minigzip start ----
	./minigzip_zstd example$(EXT)
	#cp example$(EXT).gz example$(EXT)_zstd.gz
	./minigzip_zstd -d example$(EXT).gz
	./minigzip example$(EXT)
	#cp example$(EXT).gz example$(EXT)_gz.gz
	./minigzip_zstd -d example$(EXT).gz
	@echo ---- minigzip end ----
	./zwrapbench -qi1b3B1K $(TEST_FILE)
	./zwrapbench -rqi1b1e5 ../lib ../programs ../tests

#valgrindTest: ZSTDLIBRARY = $(ZSTDLIBDIR)/libzstd.so
valgrindTest: VALGRIND = LD_LIBRARY_PATH=$(ZSTDLIBDIR) valgrind --track-origins=yes --leak-check=full --error-exitcode=1
valgrindTest: clean example fitblk example_zstd fitblk_zstd zwrapbench
	@echo "\n ---- valgrind tests ----"
	$(VALGRIND) ./example
	$(VALGRIND) ./example_zstd
	$(VALGRIND) ./fitblk 10240 <$(TEST_FILE)
	$(VALGRIND) ./fitblk 40960 <$(TEST_FILE)
	$(VALGRIND) ./fitblk_zstd 10240 <$(TEST_FILE)
	$(VALGRIND) ./fitblk_zstd 40960 <$(TEST_FILE)
	$(VALGRIND) ./zwrapbench -qi1b3B1K $(TEST_FILE)
	$(VALGRIND) ./zwrapbench -rqi1b1e5 ../lib ../programs ../tests

#.c.o:
#	$(CC) $(CFLAGS) $(CPPFLAGS) -c -o $@ $<

minigzip: $(EXAMPLE_PATH)/minigzip.o $(ZLIBWRAPPER_PATH)/zstd_zlibwrapper.o $(GZFILES) $(ZSTDLIBRARY)
	$(CC) $(LDFLAGS) $^ $(ZSTDLIBRARY) $(ZLIB_LIBRARY) -o $@

minigzip_zstd: $(EXAMPLE_PATH)/minigzip.o $(ZLIBWRAPPER_PATH)/zstdTurnedOn_zlibwrapper.o $(GZFILES) $(ZSTDLIBRARY)
	$(CC) $(LDFLAGS) $^ $(ZSTDLIBRARY) $(ZLIB_LIBRARY) -o $@

example: $(EXAMPLE_PATH)/example.o $(ZLIBWRAPPER_PATH)/zstd_zlibwrapper.o $(GZFILES) $(ZSTDLIBRARY)
	$(CC) $(LDFLAGS) $^ $(ZLIB_LIBRARY) -o $@

example_zstd: $(EXAMPLE_PATH)/example.o $(ZLIBWRAPPER_PATH)/zstdTurnedOn_zlibwrapper.o $(GZFILES) $(ZSTDLIBRARY)
	$(CC) $(LDFLAGS) $^ $(ZLIB_LIBRARY) -o $@

fitblk: $(EXAMPLE_PATH)/fitblk.o $(ZLIBWRAPPER_PATH)/zstd_zlibwrapper.o $(ZSTDLIBRARY)
	$(CC) $(LDFLAGS) $^ $(ZLIB_LIBRARY) -o $@

fitblk_zstd: $(EXAMPLE_PATH)/fitblk.o $(ZLIBWRAPPER_PATH)/zstdTurnedOn_zlibwrapper.o $(ZSTDLIBRARY)
	$(CC) $(LDFLAGS) $^ $(ZLIB_LIBRARY) -o $@

zwrapbench: $(EXAMPLE_PATH)/zwrapbench.o $(ZLIBWRAPPER_PATH)/zstd_zlibwrapper.o $(PROGRAMS_PATH)/datagen.o $(ZSTDLIBRARY)
	$(CC) $(LDFLAGS) $^ $(ZLIB_LIBRARY) -o $@


$(ZLIBWRAPPER_PATH)/zstd_zlibwrapper.o: $(ZLIBWRAPPER_PATH)/zstd_zlibwrapper.c $(ZLIBWRAPPER_PATH)/zstd_zlibwrapper.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -I. -c -o $@ $(ZLIBWRAPPER_PATH)/zstd_zlibwrapper.c

$(ZLIBWRAPPER_PATH)/zstdTurnedOn_zlibwrapper.o: $(ZLIBWRAPPER_PATH)/zstd_zlibwrapper.c $(ZLIBWRAPPER_PATH)/zstd_zlibwrapper.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -DZWRAP_USE_ZSTD=1 -I. -c -o $@ $(ZLIBWRAPPER_PATH)/zstd_zlibwrapper.c

$(ZSTDLIBDIR)/libzstd.a:
	$(MAKE) -C $(ZSTDLIBDIR) libzstd.a

$(ZSTDLIBDIR)/libzstd.so:
	$(MAKE) -C $(ZSTDLIBDIR) libzstd


clean:
	-$(RM) $(ZLIBWRAPPER_PATH)/*.o $(EXAMPLE_PATH)/*.o *.o foo.gz example$(EXT) example_zstd$(EXT) fitblk$(EXT) fitblk_zstd$(EXT) zwrapbench$(EXT) minigzip$(EXT) minigzip_zstd$(EXT)
	@echo Cleaning completed

=== debian/changelog ===
libzstd (1.3.1+dfsg-1~ubuntu0.16.04.1) xenial; urgency=medium

  * Backport to xenial (LP: #1717040):
    - d/compat, d/control: use debhelper 9 since version 10 is only in
      xenial-backports
    - d/control, d/rules: new libzstd1-dev package. Added a Provides for
      libzstd-dev to keep d-shlibmove happy.
  * d/rules: also run the clean Makefile target in the pzstd directory.

 -- Andreas Hasenack <andreas@canonical.com>  Tue, 16 Jan 2018 21:50:37 +0000

libzstd (1.3.1+dfsg-1) unstable; urgency=medium

  * Team upload
  * New upstream version
  * Exclude examples from upstream tarball
    Closes: #869581
  * debhelper 10
  * cme fix dpkg-control
  * Standards-Version: 4.1.0 (no changes needed)
  * Fix copyright

 -- Andreas Tille <tille@debian.org>  Wed, 06 Sep 2017 15:29:29 +0200

libzstd (1.2.0-1) unstable; urgency=medium

  * New upstream release (Closes: #863159).

 -- Olivier Sallou <osallou@debian.org>  Wed, 24 May 2017 11:28:27 +0000

=== debian/control ===
Source: libzstd
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Kevin Murray <kdmfoss@gmail.com>,
           Olivier Sallou <osallou@debian.org>
Section: libs
Priority: optional
Build-Depends: debhelper (>= 9),
               d-shlibs
Standards-Version: 4.1.0
Vcs-Browser: https://anonscm.debian.org/git/debian-med/libzstd.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/libzstd.git
Homepage: https://github.com/facebook/zstd

Package: libzstd1-dev
Architecture: any
Section: libdevel
Depends: libzstd1 (= ${binary:Version}),
         ${misc:Depends}
Conflicts: libzstd-dev
Provides: libzstd-dev
Description: fast lossless compression algorithm -- development files
 Zstd, short for Zstandard, is a fast lossless compression algorithm, targeting
 real-time compression scenarios at zlib-level compression ratio.
 .
 This package contains the headers and static library.

Package: libzstd1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: fast lossless compression algorithm
 Zstd, short for Zstandard, is a fast lossless compression algorithm, targeting
 real-time compression scenarios at zlib-level compression ratio.
 .
 This package contains the shared library.

Package: zstd
Architecture: any
Section: utils
Depends: libzstd1 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: fast lossless compression algorithm -- CLI tool
 Zstd, short for Zstandard, is a fast lossless compression algorithm, targeting
 real-time compression scenarios at zlib-level compression ratio.
 .
 This package contains the CLI program implementing zstd.

=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,7 @@
 export PREFIX=/usr
 
 %:
-	dh $@ --parallel
+	dh $@
 
 override_dh_auto_build:
 	dh_auto_build
@@ -19,9 +19,12 @@
 	# Call d-shlibmove to comply with library packaging guide
 	d-shlibmove --commit \
 				--multiarch \
-				--devunversioned \
 				--exclude-la \
 				--movedev "debian/tmp/usr/include/*" usr/include \
 				--movedev "debian/tmp/usr/lib/pkgconfig/*" usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
 				debian/tmp/usr/lib/lib*.so
 	dh_install
+
+override_dh_auto_clean:
+	dh_auto_clean
+	$(MAKE) -C contrib/pzstd clean

## libzstd 1.3.2+dfsg

=== debian/changelog ===
libzstd (1.3.2+dfsg-1~bpo8+1) jessie-backports-sloppy; urgency=medium

  * Rebuild for jessie-backports-sloppy.
    Closes: #882244

 -- Andreas Tille <tille@debian.org>  Mon, 20 Nov 2017 22:47:04 +0100

libzstd (1.3.2+dfsg-1) unstable; urgency=medium

  * Team upload
  * New upstream version
    Closes: #881187
  * Standards-Version: 4.1.1

 -- Andreas Tille <tille@debian.org>  Thu, 09 Nov 2017 07:55:32 +0100

libzstd (1.3.1+dfsg-2) unstable; urgency=medium

  * Team upload
  * Follow hint given by James Cowgill to recude number of threads
    on 32Bit MIPS architecture
    Closes: #876416

 -- Andreas Tille <tille@debian.org>  Fri, 22 Sep 2017 15:29:35 +0200

=== debian/control ===
--- 
+++ 
@@ -1,24 +1,21 @@
 Source: libzstd
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Kevin Murray <kdmfoss@gmail.com>,
            Olivier Sallou <osallou@debian.org>
 Section: libs
 Priority: optional
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 10),
                d-shlibs
-Standards-Version: 4.1.0
+Standards-Version: 4.1.1
 Vcs-Browser: https://anonscm.debian.org/git/debian-med/libzstd.git
 Vcs-Git: https://anonscm.debian.org/git/debian-med/libzstd.git
 Homepage: https://github.com/facebook/zstd
 
-Package: libzstd1-dev
+Package: libzstd-dev
 Architecture: any
 Section: libdevel
 Depends: libzstd1 (= ${binary:Version}),
          ${misc:Depends}
-Conflicts: libzstd-dev
-Provides: libzstd-dev
 Description: fast lossless compression algorithm -- development files
  Zstd, short for Zstandard, is a fast lossless compression algorithm, targeting
  real-time compression scenarios at zlib-level compression ratio.

=== debian/rules ===
--- 
+++ 
@@ -19,12 +19,9 @@
 	# Call d-shlibmove to comply with library packaging guide
 	d-shlibmove --commit \
 				--multiarch \
+				--devunversioned \
 				--exclude-la \
 				--movedev "debian/tmp/usr/include/*" usr/include \
 				--movedev "debian/tmp/usr/lib/pkgconfig/*" usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
 				debian/tmp/usr/lib/lib*.so
 	dh_install
-
-override_dh_auto_clean:
-	dh_auto_clean
-	$(MAKE) -C contrib/pzstd clean

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,compression=xz" \
  https://github.com/facebook/zstd/releases .*/archive/v?@ANY_VERSION@@ARCHIVE_EXT@

## libzstd 1.3.3+dfsg

=== debian/changelog ===
libzstd (1.3.3+dfsg-2ubuntu1) bionic; urgency=medium

  * Merge from Debian Unstable New queue / Vcs-Git, remaining changes:
    - d/control: New transitional package libzstd1-dev to facilitate the
    release upgrade from xenial.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 12 Mar 2018 14:57:25 +0000

libzstd (1.3.3+dfsg-2) unstable; urgency=medium

  [ Dimitri John Ledkov ]
  * Mark -dev and library packages Multi-Arch same.
  * Add libzstd1-udeb package, for btrfs-progs-udeb and others in the future.
  * Update Vcs fields for salsa.
  * Cleanup unused patches.

  [ Andreas Hasenack ]
  * d/rules: also run the clean Makefile target in the pzstd directory.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 12 Mar 2018 14:36:45 +0000

libzstd (1.3.3+dfsg-1ubuntu1) bionic; urgency=medium

  * d/control: New transitional package libzstd1-dev to facilitate the release
    upgrade from xenial (LP: #1717040)
  * d/rules: also run the clean Makefile target in the pzstd directory.

 -- Andreas Hasenack <andreas@canonical.com>  Fri, 02 Feb 2018 11:29:34 -0200

libzstd (1.3.3+dfsg-1) unstable; urgency=medium

  * Update File-Excluded list in d/copyright
  * New upstream version 1.3.3+dfsg, Closes: #883816
  * Refresh patches
  * Add zlib1g-dev to Build-Deps to enable gzip support in zstd, Closes: #883827

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Thu, 21 Dec 2017 14:25:26 +0100

libzstd (1.3.2+dfsg2-2) unstable; urgency=medium

  * Team upload.
  * Do not depend libzstd in zstd package since static linking seems
    to be the preferred way to create the executable
    Closes: #884876
  * Standards-Version: 4.1.2

 -- Andreas Tille <tille@debian.org>  Thu, 21 Dec 2017 11:43:12 +0100

libzstd (1.3.2+dfsg2-1) unstable; urgency=medium

  * Update d/copyright:
    - don't strip examples from source tarball
    - note BSD and GPL-2 license for examples
  * New upstream version 1.3.2+dfsg2
    Closes: #883271
  * Drop override_dh_auto_clean in d/rules as examples are back
  * Drop 0010-do_not_make_examples.patch as examples are back
  * Remove ruby-ronn from Build-Depends, as it renders libzstd package
    not installable on many architectures.
    Use man page shipped by upstream
  * Apply cme fix dpkg, reformat 0010-do-not.. patch header,
    fix VCS-Browser field
  * Add override for manpage-has-errors-from-man lintian warning
  * Install examples with libzstd-dev

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Fri, 01 Dec 2017 17:18:39 +0100

libzstd (1.3.2+dfsg1-1) unstable; urgency=medium

  [ Alexandre Mestiashvili ]
  * Update Files-Excluded section in d/copyright
  * New upstream version 1.3.2+dfsg1
  * Update d/rules:
    - trick dh_auto_clean with empty exmaples dir
    - force man page generation
  * Add symbols file for libzstd1
  * Add 0011-skip-long-running-tests_on_hurd.patch fixing tests on gnu hurd
  * Add d/patches/0012-typos.patch fixing a typo
  * Enable autopkgtests via d/tests/control
  * Override lintian's complain about missing man pages
  * Add myself to uploaders
  * Add ruby-ronn to build-deps, needed for man page generation

  [ Andreas Tille ]
  * d/watch: Fix version mangling

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Thu, 30 Nov 2017 23:32:41 +0100

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,34 @@
 Source: libzstd
-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Kevin Murray <kdmfoss@gmail.com>,
-           Olivier Sallou <osallou@debian.org>
+           Olivier Sallou <osallou@debian.org>,
+           Alexandre Mestiashvili <alex@biotec.tu-dresden.de>
 Section: libs
 Priority: optional
 Build-Depends: debhelper (>= 10),
-               d-shlibs
-Standards-Version: 4.1.1
-Vcs-Browser: https://anonscm.debian.org/git/debian-med/libzstd.git
-Vcs-Git: https://anonscm.debian.org/git/debian-med/libzstd.git
+               d-shlibs,
+               zlib1g-dev
+Standards-Version: 4.1.2
+Vcs-Browser: https://salsa.debian.org/med-team/libzstd
+Vcs-Git: https://salsa.debian.org/med-team/libzstd.git
 Homepage: https://github.com/facebook/zstd
+
+# can be dropped in Ubuntu 18.10
+Package: libzstd1-dev
+Architecture: any
+Section: oldlibs
+Depends: libzstd-dev (= ${binary:Version}),
+         ${misc:Depends}
+Description: transitional package for libzstd-dev
+ Zstd, short for Zstandard, is a fast lossless compression algorithm, targeting
+ real-time compression scenarios at zlib-level compression ratio.
+ .
+ This package is for transitional purposes and can be removed safely.
 
 Package: libzstd-dev
 Architecture: any
+Multi-Arch: same
 Section: libdevel
 Depends: libzstd1 (= ${binary:Version}),
          ${misc:Depends}
@@ -24,6 +40,7 @@
 
 Package: libzstd1
 Architecture: any
+Multi-Arch: same
 Section: libs
 Depends: ${shlibs:Depends},
          ${misc:Depends}
@@ -33,11 +50,23 @@
  .
  This package contains the shared library.
 
+Package: libzstd1-udeb
+XC-Package-Type: udeb
+Architecture: any
+Multi-Arch: same
+Section: debian-installer
+Depends: ${shlibs:Depends},
+         ${misc:Depends}
+Description: fast lossless compression algorithm - runtime for Debian installer
+ Zstd, short for Zstandard, is a fast lossless compression algorithm, targeting
+ real-time compression scenarios at zlib-level compression ratio.
+ .
+ This package contains the shared library for use with the Debian installer.
+
 Package: zstd
 Architecture: any
 Section: utils
-Depends: libzstd1 (= ${binary:Version}),
-         ${shlibs:Depends},
+Depends: ${shlibs:Depends},
          ${misc:Depends}
 Description: fast lossless compression algorithm -- CLI tool
  Zstd, short for Zstandard, is a fast lossless compression algorithm, targeting

=== debian/rules ===
--- 
+++ 
@@ -24,4 +24,12 @@
 				--movedev "debian/tmp/usr/include/*" usr/include \
 				--movedev "debian/tmp/usr/lib/pkgconfig/*" usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
 				debian/tmp/usr/lib/lib*.so
+	cp -r debian/libzstd1/usr debian/libzstd1-udeb/
 	dh_install
+
+override_dh_makeshlibs:
+	dh_makeshlibs -plibzstd1 --add-udeb=libzstd1-udeb
+
+override_dh_auto_clean:
+	dh_auto_clean
+	$(MAKE) -C contrib/pzstd clean

=== debian/tests/control ===
Test-Command: zstd -b1 >/dev/null 2>&1

## libzstd 1.3.5+dfsg

=== debian/changelog ===
libzstd (1.3.5+dfsg-1ubuntu1) cosmic; urgency=medium

  * Add libzstd1-udeb for btrfs-progs-udeb.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 28 Sep 2018 21:55:48 +0100

libzstd (1.3.5+dfsg-1) unstable; urgency=medium

  [ Alexandre Mestiashvili ]
  * Add attribuition for the patch
  * Fix varying number of threads in pzstd man page, making build reproducible
  * New upstream version 1.3.5+dfsg
  * Refresh and drop patches applied by upstream
  * Update d/zstd.lintian-overrides

  [ Balint Reczey ]
  * Update symbols file
  * Allow Invoking `zstd --list` When `stdin` is not a `tty`

 -- Alexandre Mestiashvili <mestia@debian.org>  Tue, 21 Aug 2018 15:32:44 +0000

libzstd (1.3.4+dfsg-3) unstable; urgency=medium

  * Add patch provided by Chris Lamb making build reproducible,
    Closes: #897904
  * Update patch skipping heavy tests on mips(el) and hurd
  * Add patch fixing tests on GNU/Hurd
  * Drop not needed override_dh_auto_test

 -- Alexandre Mestiashvili <mestia@debian.org>  Wed, 09 May 2018 19:25:10 +0200

libzstd (1.3.4+dfsg-2) unstable; urgency=medium

  * Add liblzma-dev and liblz4-dev to build-depends to enable xz and lz4 support
  * Patch tests to avoid FTBFS on mips(el) architectures
  * Use help2man for pzstd man page, drop patches providing obsolete man pages
  * Update zstd.lintian-overrides, add more binaries without man pages
  * Add override for dh_auto_test, on hurd run only simple tests
  * Update 0012-typos.patch, forward to upstream

 -- Alexandre Mestiashvili <mestia@debian.org>  Wed, 02 May 2018 15:43:16 +0200

libzstd (1.3.4+dfsg-1) unstable; urgency=medium

  * Team upload.

  [ Alexandre Mestiashvili ]
  * New upstream version 1.3.4+dfsg
  * Refresh patches, remove indexes
  * Update d/libzstd1.symbols fixing minimal-version
  * Update d/copyright, starting from 1.3.1 patent claim is removed
  * Add comments to unstable symbols

  [ Mattia Rizzolo ]
  * Update copyright after the new upstream release.

  [ Sascha Steinbiss ]
  * Remove obsolete patch.
  * Reword patch description.

 -- Alexandre Mestiashvili <mestia@debian.org>  Wed, 25 Apr 2018 10:39:39 +0200

=== debian/control ===
Source: libzstd
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Kevin Murray <kdmfoss@gmail.com>,
           Olivier Sallou <osallou@debian.org>,
           Alexandre Mestiashvili <mestia@debian.org>
Section: libs
Priority: optional
Build-Depends: d-shlibs,
               debhelper (>= 11),
               help2man,
               liblz4-dev,
               liblzma-dev,
               zlib1g-dev
Standards-Version: 4.1.4
Vcs-Browser: https://salsa.debian.org/med-team/libzstd
Vcs-Git: https://salsa.debian.org/med-team/libzstd.git
Homepage: https://github.com/facebook/zstd

Package: libzstd-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libzstd1 (= ${binary:Version}), ${misc:Depends}
Description: fast lossless compression algorithm -- development files
 Zstd, short for Zstandard, is a fast lossless compression algorithm, targeting
 real-time compression scenarios at zlib-level compression ratio.
 .
 This package contains the headers and static library.

Package: libzstd1
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: fast lossless compression algorithm
 Zstd, short for Zstandard, is a fast lossless compression algorithm, targeting
 real-time compression scenarios at zlib-level compression ratio.
 .
 This package contains the shared library.

Package: libzstd1-udeb
XC-Package-Type: udeb
Architecture: any
Multi-Arch: same
Section: debian-installer
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: fast lossless compression algorithm - runtime for Debian installer
 Zstd, short for Zstandard, is a fast lossless compression algorithm, targeting
 real-time compression scenarios at zlib-level compression ratio.
 .
 This package contains the shared library for use with the Debian installer.

Package: zstd
Architecture: any
Section: utils
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: fast lossless compression algorithm -- CLI tool
 Zstd, short for Zstandard, is a fast lossless compression algorithm, targeting
 real-time compression scenarios at zlib-level compression ratio.
 .
 This package contains the CLI program implementing zstd.

=== debian/rules ===
--- 
+++ 
@@ -3,17 +3,30 @@
 export DH_VERBOSE=1
 
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
+DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 
 # Upstream's makefiles will respect PREFIX, and this means we avoid a patch
 export PREFIX=/usr
 
+HELP2MAN = help2man --no-info --help-option="'-h'" --no-discard-stderr
+mandir := $(CURDIR)/debian/zstd/usr/share/man/man1
+
 %:
 	dh $@
 
+DH_AUTO_CONFIGURE_OPTS :=
+ifneq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+	DH_AUTO_CONFIGURE_OPTS += -DZSTD_BUILD_TESTS:BOOL=OFF
+endif
+
+override_dh_auto_clean:
+	dh_auto_clean
+	dh_auto_clean --sourcedirectory=contrib/pzstd
+
 override_dh_auto_build:
 	dh_auto_build
-	$(MAKE) -C contrib/pzstd/ pzstd
+	dh_auto_build --sourcedirectory=contrib/pzstd/ -- pzstd
 
 override_dh_install:
 	# Call d-shlibmove to comply with library packaging guide
@@ -30,6 +43,8 @@
 override_dh_makeshlibs:
 	dh_makeshlibs -plibzstd1 --add-udeb=libzstd1-udeb
 
-override_dh_auto_clean:
-	dh_auto_clean
-	$(MAKE) -C contrib/pzstd clean
+override_dh_installman:
+	dh_installman
+	mkdir -p $(mandir)
+	$(HELP2MAN) --name='parallelised Zstandard compression, al la pigz' contrib/pzstd/pzstd \
+	| perl -pe 's/(\(de\)compression\s\(default:)(\d+)(\))/$$1 All$$3/g' >$(mandir)/pzstd.1
